/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
/*                       Les include pour GTK                           */
/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/

#include"interface_GTK_specific.h"

#include <gdk/gdkkeysyms.h>
#define DATADIR "../pixmaps"
/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
/*                        Les include "standard"                        */
/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/

#include 	<stdio.h>
#include 	<stdlib.h>

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
/*                    Les include de l'application                      */
/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/

#include 	"interface_extern.h"
#include 	"interface_needs.h"
#include 	"interface_GTK.h"

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
/*           Les variables globales (protegees) du module GTK           */
/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
static GtkWidget *MainWindow;
static GtkWidget *BoitePrincipale;

static GtkWidget *BoiteHaut;
static GtkWidget *LigneHaut;
static GtkWidget *BoiteJeu;

static GtkWidget *Partie_jeu;
static GtkWidget *Partie_joueur[2];
static GtkWidget *LigneSep[2];
static GtkWidget *LigneSep2;

/* Images du Jeu */
static GtkWidget *Dessin[2];
static GdkPixmap *PixmapFront[2] = {NULL, NULL};
static GdkPixbuf *PixbufFond[2];
GdkGC            *DessinGC[2];

/* Des Images de vaisseaux, de monstres...*/
static Sprite SpriteVaisseau[NB_VAISSEAU][4] ;
static Sprite SpriteMonstre[NB_MONSTRE][4] ;
static Sprite SpriteMur[NB_MUR] ;
static Sprite SpriteTirVaisseau[NB_TIRS_VAISSEAU] ;
static Sprite SpriteTirEnnemi[NB_TIRS_ENNEMIS] ;
static Sprite SpritePastille[NB_PASTILLES];
static Sprite SpriteVies;
static Sprite SpriteEnergie;

/* Noms des joueurs */
static GtkWidget *BoiteJoueur[2];
static GtkWidget *TexteJoueur[2];

/* Nombre de Lignes */
static GtkWidget *BoiteKilled[2];
static GtkWidget *TexteKilled[2];
static GtkWidget *ValKilled[2];

/* Scores */
static GtkWidget *BoiteScore[2];
static GtkWidget *TexteScore[2];
static GtkWidget *ValScores[2];

/* Niveau */
static GtkWidget *BoiteNiveau;
static GtkWidget *TexteNiveau;
static GtkWidget *BarreNiveau;
static GtkAdjustment *adjustment;
/**/

static GtkWidget *BoutonJouer;
static GtkWidget *BoutonQuitter;

/* Des separateurs pour faire joli */
static GtkWidget *JoueurSep1;
static GtkWidget *JoueurSep[2];

static guint Timer=0; 	      /* horloge fixe */

static char mouvement[NB_TOUCHES];   /* Une struture qui dit si les touches haut/bas/gauche/droite/tir */
/* sont encore enfoncees...*/

/************************/
/* Creation des widgets */
/************************/

static void Make_Widgets(int nb_players, int nb_ecrans) {
  int i;
  int j;
  /* Une boite principale dans la fenetre */
  BoitePrincipale = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (BoitePrincipale, "BoitePrincipale");
  gtk_widget_show (BoitePrincipale);
  gtk_container_add (GTK_CONTAINER (MainWindow), BoitePrincipale);

  /* Boite du Haut  : Boutons + Niveau */
  BoiteHaut = gtk_hbox_new (FALSE, 10);
  gtk_box_pack_start (GTK_BOX (BoitePrincipale), BoiteHaut, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (BoiteHaut), 10);
  gtk_widget_show (BoiteHaut);

  BoutonJouer = gtk_button_new_with_label ("Jouer");
  gtk_widget_set_usize(BoutonJouer, LARG_BOUTON, HAUT_BOUTON);
  gtk_widget_show (BoutonJouer);
  gtk_box_pack_start (GTK_BOX (BoiteHaut), BoutonJouer, FALSE, FALSE, 0);

  BoutonQuitter = gtk_button_new_with_label ("Quitter");
  gtk_widget_set_usize(BoutonQuitter, LARG_BOUTON, HAUT_BOUTON);
  gtk_widget_show (BoutonQuitter);
  gtk_box_pack_start (GTK_BOX (BoiteHaut), BoutonQuitter, FALSE, FALSE, 0);

  BoiteNiveau = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (BoiteHaut), BoiteNiveau, TRUE, TRUE, 0);
  gtk_widget_show (BoiteNiveau);

  TexteNiveau = gtk_label_new("Niveau");
  gtk_box_pack_start (GTK_BOX (BoiteNiveau), TexteNiveau, TRUE, TRUE, 0);
  gtk_widget_show (TexteNiveau);
    
  adjustment = (GtkAdjustment *)gtk_adjustment_new(1,1,10,0,0,0);
  BarreNiveau = gtk_hscale_new(adjustment);
  gtk_scale_set_digits((GtkScale *)BarreNiveau,0);
  /*BarreNiveau = gtk_hscale_new_with_range(1,10,1);
  gtk_range_set_value ( (GtkRange*) BarreNiveau, 1);*/
  gtk_box_pack_start (GTK_BOX (BoiteNiveau), BarreNiveau, FALSE, FALSE, 0);
  gtk_widget_show (BarreNiveau);

  LigneHaut = gtk_hseparator_new();
  gtk_widget_show (LigneHaut);
  gtk_box_pack_start (GTK_BOX (BoitePrincipale), LigneHaut, FALSE, FALSE, 0);

  /* Puis une boite horizontale pour caser les elements */
  BoiteJeu = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (BoiteJeu, "BoiteJeu");
  gtk_widget_show (BoiteJeu);
  gtk_box_pack_start (GTK_BOX (BoitePrincipale), BoiteJeu, FALSE, FALSE, 0);
  
  JoueurSep1 = gtk_hseparator_new();
  gtk_widget_show (JoueurSep1);
  gtk_box_pack_start (GTK_BOX (BoiteJeu), JoueurSep1, FALSE, FALSE, 10);
  
  for(j=0;j<nb_ecrans;j++) {
    /* Dessin */
    Dessin[j] = gtk_drawing_area_new ();
    gtk_widget_show (Dessin[j]);
    gtk_box_pack_start (GTK_BOX (BoiteJeu), Dessin[j], FALSE, FALSE, 0);
    gtk_widget_set_usize(Dessin[j], LARG_JEU, HAUT_JEU);
    
    JoueurSep[j] = gtk_hseparator_new();
    gtk_widget_show (JoueurSep[j]);
    gtk_box_pack_start (GTK_BOX (BoiteJeu), JoueurSep[j], FALSE, FALSE, 10);
  }
  /************/
  /* Partie Jeu  */
  /***********/

  Partie_jeu = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (Partie_jeu);
  gtk_box_pack_start (GTK_BOX (BoitePrincipale), Partie_jeu, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (Partie_jeu), 10);

  
  for(i=JOUEUR1;i<nb_players;i++) {  
    /* Informations propres aux joueur i */
    char buff[16];
    sprintf(buff,"Joueur %d",i+1);
    
    LigneSep[i] = gtk_vseparator_new();
    gtk_widget_show (LigneSep[i]);
    gtk_box_pack_start (GTK_BOX (Partie_jeu), LigneSep[i], FALSE, FALSE, 0);
    
    Partie_joueur[i] = gtk_vbox_new (FALSE, 0);
    gtk_widget_show (Partie_joueur[i]);
    gtk_box_pack_start (GTK_BOX (Partie_jeu), Partie_joueur[i], TRUE, TRUE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (Partie_joueur[i]), 10);
 
    BoiteJoueur[i] = gtk_vbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (Partie_joueur[i]), BoiteJoueur[i], TRUE, TRUE, 0);
    gtk_widget_show (BoiteJoueur[i]);
    
    TexteJoueur[i] = gtk_label_new(buff);
    gtk_box_pack_start (GTK_BOX (BoiteJoueur[i]), TexteJoueur[i], TRUE, TRUE, 0);
    gtk_widget_show (TexteJoueur[i]);
    
    BoiteKilled[i] = gtk_hbox_new (FALSE, 10);
    gtk_box_pack_start (GTK_BOX (Partie_joueur[i]), BoiteKilled[i], i==JOUEUR2, i==JOUEUR2, 0);
    gtk_widget_show (BoiteKilled[i]);
    
    TexteKilled[i] = gtk_label_new("Ennemis Detruits");
    gtk_box_pack_start (GTK_BOX (BoiteKilled[i]), TexteKilled[i], FALSE, FALSE, 0);
    gtk_widget_show (TexteKilled[i]);
    
    ValKilled[i] = gtk_label_new("0");
    gtk_box_pack_end (GTK_BOX (BoiteKilled[i]), ValKilled[i], FALSE, FALSE, 0);
    gtk_widget_show (ValKilled[i]);
    
    BoiteScore[i] = gtk_hbox_new (FALSE, 10);
    gtk_box_pack_start (GTK_BOX (Partie_joueur[i]), BoiteScore[i], i==JOUEUR2, i==JOUEUR2, 0);
    gtk_widget_show (BoiteScore[i]);
    
    TexteScore[i] = gtk_label_new("Score");
    gtk_box_pack_start (GTK_BOX (BoiteScore[i]), TexteScore[i], FALSE, FALSE, 0);
    gtk_widget_show (TexteScore[i]);
    
    ValScores[i] = gtk_label_new("0");
    gtk_box_pack_end (GTK_BOX (BoiteScore[i]), ValScores[i], FALSE, FALSE, 0);
    gtk_widget_show (ValScores[i]);
  }
    LigneSep2 = gtk_vseparator_new();
    gtk_widget_show (LigneSep2);
    gtk_box_pack_end (GTK_BOX (Partie_jeu), LigneSep2, FALSE, FALSE, 0);
}


/****************************************************************/
/* Evenements dans la fenetre : appui sur une touche du clavier */
/****************************************************************/
static gint MainWindow_key_event(GtkWidget *widget,
				 GdkEventKey *event) {
  gint key = event->keyval;

  switch(key)
    {
    case GDK_Left :
      if (event->type == GDK_KEY_PRESS )
	mouvement[GAUCHE1] =1;
      else if (event->type == GDK_KEY_RELEASE )
	mouvement[GAUCHE1] =0;
      break;
    case GDK_Right :
      if (event->type == GDK_KEY_PRESS )
	mouvement[DROITE1] =1;
      else if (event->type == GDK_KEY_RELEASE )
	mouvement[DROITE1] =0;
      break;
    case GDK_Down :
      if (event->type == GDK_KEY_PRESS )
	mouvement[BAS1] =1;
      else if (event->type == GDK_KEY_RELEASE )
	mouvement[BAS1] =0;
      break;
    case GDK_Up :
      if (event->type == GDK_KEY_PRESS )
	mouvement[HAUT1] =1;
      else if (event->type == GDK_KEY_RELEASE )
	mouvement[HAUT1] =0;
      break;
    case GDK_m :
      if (event->type == GDK_KEY_PRESS )
	mouvement[TIR1] =1;
      else if (event->type == GDK_KEY_RELEASE )
	mouvement[TIR1] =0;
      break;
    case GDK_a :
      if (event->type == GDK_KEY_PRESS )
	mouvement[GAUCHE2] =1;
      else if (event->type == GDK_KEY_RELEASE )
	mouvement[GAUCHE2] =0;
      break;
    case GDK_e :
      if (event->type == GDK_KEY_PRESS )
	mouvement[DROITE2] =1;
      else if (event->type == GDK_KEY_RELEASE )
	mouvement[DROITE2] =0;
      break;
    case GDK_s :
      if (event->type == GDK_KEY_PRESS )
	mouvement[BAS2] =1;
      else if (event->type == GDK_KEY_RELEASE )
	mouvement[BAS2] =0;
      break;
    case GDK_z :
      if (event->type == GDK_KEY_PRESS )
	mouvement[HAUT2] =1;
      else if (event->type == GDK_KEY_RELEASE )
	mouvement[HAUT2] =0;
      break;
    case GDK_t :
      if (event->type == GDK_KEY_PRESS )
	mouvement[TIR2] =1;
      else if (event->type == GDK_KEY_RELEASE )
	mouvement[TIR2] =0;
      break;
    default :
      return FALSE;
      break;
    }

  return TRUE;

}

/*************************************************************
 * Definition des handlers associes aux evenements :
 *    cache, fermeture d'une zone ou de la fenetre.
 *    Attachement des boutons a une procedure
 ************************************************************/

/***********************************
 * Configurer l'image du Jeu
 ***********************************/
static gint ImgJeu_configure_event(GtkWidget *widget,
				   GdkEventExpose *event, gpointer data) {

  int ecran = (int)data;

  if (PixmapFront[ecran]) {
    
    specific_unref(PixmapFront[ecran]);
  }
  
  /* On se prepare une belle image */
  PixmapFront[ecran] = gdk_pixmap_new(widget->window,
				widget->allocation.width,
				widget->allocation.height,
				-1);

  
  gdk_draw_rectangle(PixmapFront[ecran],
		     widget->style->black_gc,
		     TRUE, 0, 0,
		     widget->allocation.width,
		     widget->allocation.height);
  
  /* On la colle dans la fenetre*/

  gdk_draw_pixmap (widget->window ,
		     widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		     PixmapFront[ecran], event->area.x, event->area.y,
		     event->area.x, event->area.y,
		     event->area.width, event->area.height); 
  return FALSE;
}

/***********************************
 * Reafficher l'image du Jeu
 ***********************************/
static gint ImgJeu_expose_event(GtkWidget *widget,
				GdkEventExpose *event, gpointer data) {
  int ecran = (int)data;
  gdk_draw_pixmap (widget->window,
		     widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		     PixmapFront[ecran], event->area.x, event->area.y,
		     event->area.x, event->area.y,
		     event->area.width, event->area.height); 

  return FALSE;
}

/***********************************
 * Destruction des objets
 ***********************************/


gint Destroy_And_Quit(GtkWidget* button, gpointer user_data) {
  Quitter();
  gtk_main_quit();
  
  return 0;
}

void Init_Mouvement() {
  int i;
  for (i=0;i<NB_TOUCHES;i++) {
    mouvement[i] = 0;  
  }
}

gint Go(GtkWidget* button, gpointer user_data) {
  Init_Mouvement();
  Jouer();

  return 0;
}

/****************************************************************/
/* Procedure executee a chaque tour de jeu  Fixe par l'horloge  */
/* Timer 							*/
/****************************************************************/

static gint timeout_event(GtkWidget *widget, GdkEventExpose *event) {
  Timer_fini();
  Touches_Enfoncees(mouvement);
  return TRUE;
}

GdkPixbuf *new_pixbuf_file(char* filename) {
  GdkPixbuf *pixbuf; 
  char directory_filename [128];
  
  sprintf(directory_filename,"%s/%s",DATADIR,filename);
  
  pixbuf = specific_gdk_pixbuf_new_from_file(directory_filename);

  if (!pixbuf) {
    g_print("Could not load `%s'!\n", directory_filename);
    exit (1);
  }
  return pixbuf;
}

void sprite_from_file(Sprite *sprite, char* filename) {
  GdkPixbuf *pixbuf = new_pixbuf_file(filename);
  gdk_pixbuf_render_pixmap_and_mask (pixbuf, &(sprite->pixmap), &(sprite->mask), 2);
  sprite->width = gdk_pixbuf_get_width(pixbuf);
  sprite->height = gdk_pixbuf_get_height(pixbuf);
}

static void Make_Graphics(int nb_ecrans) {
  //int i;

  sprite_from_file(&SpriteVaisseau[0][0],"iupacman_vaisseau1_haut.png");
  sprite_from_file(&SpriteVaisseau[0][1],"iupacman_vaisseau1_droit.png");
  sprite_from_file(&SpriteVaisseau[0][2],"iupacman_vaisseau1_bas.png");
  sprite_from_file(&SpriteVaisseau[0][3],"iupacman_vaisseau1_gauche.png");
  sprite_from_file(&SpriteVaisseau[1][0],"iupacman_vaisseau2_haut.png");
  sprite_from_file(&SpriteVaisseau[1][1],"iupacman_vaisseau2_droit.png");
  sprite_from_file(&SpriteVaisseau[1][2],"iupacman_vaisseau2_bas.png");
  sprite_from_file(&SpriteVaisseau[1][3],"iupacman_vaisseau2_gauche.png");

  sprite_from_file(&SpriteMonstre[0][0],"iupacman_monstre1_haut.png");
  sprite_from_file(&SpriteMonstre[0][1],"iupacman_monstre1_droit.png");
  sprite_from_file(&SpriteMonstre[0][2],"iupacman_monstre1_bas.png");
  sprite_from_file(&SpriteMonstre[0][3],"iupacman_monstre1_gauche.png");
  sprite_from_file(&SpriteMonstre[1][0],"iupacman_monstre2_haut.png");
  sprite_from_file(&SpriteMonstre[1][1],"iupacman_monstre2_droit.png");
  sprite_from_file(&SpriteMonstre[1][2],"iupacman_monstre2_bas.png");
  sprite_from_file(&SpriteMonstre[1][3],"iupacman_monstre2_gauche.png");
  sprite_from_file(&SpriteMonstre[2][0],"iupacman_monstre3_haut.png");
  sprite_from_file(&SpriteMonstre[2][1],"iupacman_monstre3_droit.png");
  sprite_from_file(&SpriteMonstre[2][2],"iupacman_monstre3_bas.png");
  sprite_from_file(&SpriteMonstre[2][3],"iupacman_monstre3_gauche.png");

  sprite_from_file(&SpriteTirVaisseau[0],"iupacman_tir_vaisseau1.png");
  sprite_from_file(&SpriteTirVaisseau[1],"iupacman_tir_vaisseau2.png");

  sprite_from_file(&SpriteTirEnnemi[0],"iupacman_tir_ennemi1.png");
  sprite_from_file(&SpriteTirEnnemi[1],"iupacman_tir_ennemi2.png");

  sprite_from_file(&SpritePastille[0],"iupacman_pastille1.png");
  sprite_from_file(&SpritePastille[1],"iupacman_pastille2.png");

  sprite_from_file(&SpriteMur[0],"iupacman_mur1.png");
  sprite_from_file(&SpriteMur[1],"iupacman_mur2.png");

  sprite_from_file(&SpriteVies,"iupacman_vies.png");
  sprite_from_file(&SpriteEnergie,"iupacman_energie.png");


  PixbufFond[0] = new_pixbuf_file("iupacman_fond_ecran1.png");
  PixbufFond[1] = new_pixbuf_file("iupacman_fond_ecran2.png");

}

void Make_Callback(int nb_ecrans) {
 int i;

  /* Les Boutons de Jeu */
  specific_signal_connect (BoutonJouer, "clicked", Go, NULL);
  specific_signal_connect (BoutonQuitter, "clicked", Destroy_And_Quit, NULL);

  /* La fenetre principale */
  specific_signal_connect (MainWindow, "destroy", Destroy_And_Quit, NULL);

  /* La region Jeu */
  for(i=0;i<nb_ecrans;i++) {
    specific_signal_connect (Dessin[i], "expose_event", ImgJeu_expose_event, (gpointer)i);
    specific_signal_connect (Dessin[i], "configure_event", ImgJeu_configure_event, (gpointer)i);
  }
  /* Appui clavier */
  specific_signal_connect (MainWindow, "key_press_event", MainWindow_key_event, NULL);
  specific_signal_connect (MainWindow, "key_release_event", MainWindow_key_event, NULL);
}



void Make_Colors(int nb_ecrans) {
  int i;
  for(i=0;i<nb_ecrans;i++) {
    DessinGC[i] = gdk_gc_new(Dessin[i]->window);
  }
}

/*********************************************************************/
/* Affichage dans une widget selon un contexte graphique et dans une */
/* certaine position d'une chaine de caracteres                      */
/* Meme fonction pour la zone de dessin                              */
/*********************************************************************/

static void Affiche_Chaine(GtkWidget *w, char *chaine) {
  gtk_label_set_text( (GtkLabel *) w, chaine);
}

/************************************************************/
/* Les primitives d'affichage dans les differentes fenetres */
/************************************************************/

void Afficher_Score(int score, int num_joueur) {
  char chaine[TAILLE_MSG];

  sprintf(chaine,"%d",score);
  Affiche_Chaine(ValScores[num_joueur], chaine);

}

void Afficher_Killed(int killed, int num_joueur) {
  char chaine[TAILLE_MSG];

  sprintf(chaine,"%d",killed);
  Affiche_Chaine(ValKilled[num_joueur], chaine);
}

/******************************************************************/
/* Toutes les initialisations GTK et le lancement de l'appli GTK avec */
/* affichage de l'interface GTK                                     */
/******************************************************************/

void Interface_Jeu(int nb_players,int nb_ecrans) {
  gtk_init(NULL,NULL);

  MainWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);

  specific_gtk_window_set_resizable((GtkWindow *)MainWindow);

  Make_Widgets(nb_players,nb_ecrans);

  gtk_widget_set_events(MainWindow, GDK_KEY_RELEASE_MASK);

  Make_Callback(nb_ecrans);

  gtk_widget_show (MainWindow);
  Make_Colors(nb_ecrans);
  Make_Graphics(nb_ecrans);

  gtk_main();
}

/*****************************************************/
/* Lecture du nom du joueur (par defaut : anonyme) */
/*****************************************************/

void Changer_Nom_Joueur( char *nom, int num_joueur ) {
  Affiche_Chaine(TexteJoueur[num_joueur], nom);
}

/****************************************************/
/* Lecture du niveau dans la widget associee */
/****************************************************/

void Lire_Niveau(int * niveau) {
  /*gdouble gniv = gtk_range_get_value((GtkRange*) BarreNiveau);*/
  *niveau = (int)(adjustment->value);
}


void Afficher_Niveau(int niveau) {
  gtk_adjustment_set_value (adjustment, (gdouble) niveau);
  /*gtk_adjustment_value_changed (adjustment);*/
  /*gtk_range_set_value ((GtkRange*) BarreNiveau, gniv);*/
}


/*************************************/
/* Affichage de l'etat du jeu actuel */
/*************************************/
void Afficher_Ecran(int num_ecran) {
  gtk_widget_queue_draw_area (Dessin[num_ecran],
			      0,
			      0,
			      Dessin[num_ecran]->allocation.width,
			      Dessin[num_ecran]->allocation.height);
}

void Preparer_Fond(int num_ecran,int num_fond) {
  num_fond=num_fond%2;
  num_ecran=num_ecran%2;
  gdk_pixbuf_render_to_drawable_alpha(PixbufFond[num_fond],
				      PixmapFront[num_ecran],
				      0,
				      0,
				      0,
				      0,
				      gdk_pixbuf_get_width(PixbufFond[num_ecran]),
				      gdk_pixbuf_get_height(PixbufFond[num_ecran]),
				      GDK_PIXBUF_ALPHA_BILEVEL,
				      0,
				      GDK_RGB_DITHER_NONE,
				      0,
				      0);
}

void Preparer_Sprite(int num_ecran, Sprite sprite, int x, int y) {
  /* --- Set up the clip mask and origin --- */
  gdk_gc_set_clip_mask (DessinGC[num_ecran], sprite.mask);
  gdk_gc_set_clip_origin (DessinGC[num_ecran], x, y);

  /* --- Copy sprite to the pixmap --- */
  gdk_draw_pixmap (PixmapFront[num_ecran], DessinGC[num_ecran], sprite.pixmap, 0, 0, x, y, -1, -1);

  /* --- Clear the clip mask when done. --- */
  /* gdk_gc_set_clip_mask (DessinGC[num_ecran], NULL); */

}

void Preparer_Vaisseau(int num_ecran, int num_vaisseau, int direction, int x, int y) {
  num_vaisseau = num_vaisseau%NB_VAISSEAU;
  direction=direction%4;
  Preparer_Sprite(num_ecran, SpriteVaisseau[num_vaisseau][direction], x, y);
}

void Preparer_Tir_Vaisseau(int num_ecran, int num_tir, int x, int y) {
  num_tir = num_tir%NB_VAISSEAU;
  Preparer_Sprite(num_ecran, SpriteTirVaisseau[num_tir], x, y);
}

void Preparer_Mur(int num_ecran, int num_mur, int x, int y) {
  num_mur = num_mur%NB_MUR;
  Preparer_Sprite(num_ecran, SpriteMur[num_mur], x, y);
}


void Preparer_Tir_Ennemi(int num_ecran, int num_tir, int x, int y) {
  num_tir = num_tir%NB_VAISSEAU;
  Preparer_Sprite(num_ecran, SpriteTirEnnemi[num_tir], x, y);
}

void Preparer_Monstre(int num_ecran, int num_monstre, int direction, int x, int y) {
  num_monstre = num_monstre%NB_MONSTRE;
  direction = direction%4;
  Preparer_Sprite(num_ecran, SpriteMonstre[num_monstre][direction], x, y);
}

void Preparer_Pastille(int num_ecran, int num_pastille, int x, int y) {
  num_pastille = num_pastille%NB_MONSTRE;
  Preparer_Sprite(num_ecran, SpritePastille[num_pastille], x, y);
}

void Preparer_Vies(int num_ecran, int num_joueur, int vies) {
  int i;

  for (i=vies-1;i>=0;i--) {
    Preparer_Sprite(num_ecran,
		    SpriteVies,
		    (Dessin[num_ecran]->allocation.width-SpriteVies.width-22)*num_joueur+5,
		    Dessin[num_ecran]->allocation.height-(SpriteVies.height+2)*(i+1));
  }
}

void Preparer_Energie(int num_ecran, int num_joueur, int energie) {
  int i;

  for (i=energie-1;i>=0;i--)
    Preparer_Sprite(num_ecran,
		    SpriteEnergie,
		    (Dessin[num_ecran]->allocation.width-26-3*SpriteVies.width)*num_joueur+332+SpriteVies.width,
		    Dessin[num_ecran]->allocation.height-(SpriteEnergie.height+2)*(i+1));
}


/****************************************************************/
/* Procedure qui branche un timer de difficulte millisecondes   */
/* et indique la procedure a executer une fois le delai expire  */
/****************************************************************/
/*
void Debrancher_Timer_Vaisseau(void) {

  if (TimerVaisseau != 0)
    gtk_timeout_remove (TimerVaisseau);

  TimerVaisseau =0;
}

void Brancher_Timer_Vaisseau(int millisecondes) {

  Debrancher_Timer_Vaisseau();


  TimerVaisseau = gtk_timeout_add (millisecondes,
				   (GtkFunction) timeout_event_vaisseau, 
				   NULL);
}
*/
void Debrancher_Timer(void) {
  /* On detruit le timer */
  /* if (Timer != 0) */
    gtk_timeout_remove (Timer);
  
/* Timer =0; */
}

void Brancher_Timer(int millisecondes) {
 
  Debrancher_Timer();
  
  /* On en recree un */
  Timer = gtk_timeout_add (millisecondes,
			   (GtkFunction) timeout_event, 
			   NULL);
}

/* Ceci pour la fin du jeu */
void Game_Over(char *text) {
  specific_game_over(text, MainWindow);
}

int Largeur_Jeu(void) { 
  return Dessin[0]->allocation.width;
}

int Hauteur_Jeu(void) {
  return Dessin[0]->allocation.height;
}

int Largeur_Vaisseau(void) {
  return SpriteVaisseau[0][0].width;
}

int Hauteur_Vaisseau(void) {
  return SpriteVaisseau[0][0].height;
}
  
int Hauteur_Monstre(void) {
  return SpriteMonstre[0][0].height;
}

int Largeur_Monstre(void) {
  return SpriteMonstre[0][0].width;
}
  
int Largeur_Tir_Vaisseau(void) {
  return SpriteTirVaisseau[0].width;
}
  
int Hauteur_Tir_Vaisseau(void) {
  return SpriteTirVaisseau[0].height;
}

int Largeur_Tir_Ennemi(void) {
  return SpriteTirEnnemi[0].width;
}
  
int Hauteur_Tir_Ennemi(void) {
  return SpriteTirEnnemi[0].height;
}

int Largeur_Pastille(void) {
  return SpritePastille[0].width;
}
  
int Hauteur_Pastille(void) {
  return SpritePastille[0].height;
}

