#ifndef _JEU_H
#define _JEU_H

/***************************
 *      Les Structures      *
 ****************************/

#define DELAY_INVULNERABLE 300

enum TYPES
{
  TYPE_MONSTRE, TYPE_BOSS , TYPE_TIR_VAISSEAU , TYPE_TIR_ENNEMI , TYPE_PASTILLE 
};

enum JOUEUR
{
  JOUEUR1, JOUEUR2
};

enum _TOUCHE
{
  DROITE,GAUCHE,HAUT,BAS,TIR
};

enum VULN
{
  VULNERABLE, INVULNERABLE
};

/* definition d'une fonction generique de calcul de trajectoire
   void (*traj)(int x0, int y0 , int temps, int vitesse, int *x, int *y); */
typedef void (*traj)(int, short, short *, short *); 

typedef struct aShip {
  char ct;   /* Controle Technique : si 0 : fini */
  char etat;   /* 1 si invulnerable  */
  char vitesse;	/* nb de pixels par deplacement */
  char type_tir;
  short x;      /* position verticale du coin sup gauche du vaisseau dans l'ecran */
  /*     en haut : 0. En Bas : HAUT_JEU-1 */
  short y;      /* Position horizontale du coin sup gauche du vaisseau dans l'ecran */
  short direction;     /* direction du vaisseau : 0 = up 1 = right 2= down 3= left */
  /*     a gauche : 0. a droite Haut : LARG_JEU-1 */
  short width;
  short height;
  short debut_invulnerable;
} ship;

typedef struct unJoueur {
  char nom_joueur[32];
  char vies;
  char delay_between_fire;
  char timeSinceLastShot;
  int score;
  int killed;
  ship vaisseau;
  int boss_present; /* appartient plus a un ecran qu'a un joueur, mais bon */
} donnees_joueur;

/* POUR LES MONSTRES / TIRS / PASTILLES */
typedef struct bestiau {
  char type;   /* 0 : Monstre, 1 : Boss, 2: Tir */
  char ct;   /* Controle Technique : si 0 : fini */
  char vitesse;
  char dir;
  char pourcent_tir; /* indice de facilite de la gachette (100 = tir chaque tour) */
  short x;    
  short y;          
  short  width;
  short  height;
  int  temps;
  int  numero; /* numeor du bestiau ou du joueur qui a tir */
  traj traj_elt;
} element_mouvant;

typedef struct unnoeud {
  element_mouvant elt; 
  struct unnoeud* suivant;
  struct unnoeud* prec;
} noeud;

typedef noeud * liste_elt;

typedef struct utils_jeu {
  int temps;
  int niveau;
  short largeur_jeu;
  short hauteur_jeu;
  
  short largeur_vaisseau;
  short hauteur_vaisseau;
  
  short largeur_monstre;
  short hauteur_monstre;
  
  short largeur_tir;
  short hauteur_tir;
  
  short largeur_pastille;
  short hauteur_pastille;
  
  /* Liste des monstres (et tirs) */
  liste_elt l_monstres [2];
  liste_elt l_tirs_ennemis [2];
  liste_elt l_tirs_vaisseaux [2];
  liste_elt l_pastilles [2];
  int nb_players;
  int nb_ecrans;
  int invulnerable;
} donnees_jeu;

#endif /* _JEU_H */
