
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include "interface_extern.h"

void usage(char * appliname) {
  fprintf(stdout,"Usage:\n");
  fprintf(stdout,"\t%s [OPTION]\n\n",appliname);
  fprintf(stdout,"OPTIONS:\n");
  fprintf(stdout,"\t-1,-p1,--nbplayers=1\t\tOne-player game\n");
  fprintf(stdout,"\t-2,-p2,-d1,--nbplayers=2\tTwo-player game\n");
  fprintf(stdout,"\t-d2,--nbdisplays=2\t\tTwo-player two-display game\n");
  fprintf(stdout,"\t-h,-?,--help\t\t\tDisplays this help\n");
  fprintf(stdout,"\t-i,--invulnerable\t\tPlayers are invulnerable\n");
}

int main(int argc,char *argv[]) {
  /* ici on teste les arguments (les options) passs en ligne de commande etc. */
  int nb_players = 2;
  int nb_displays = 2;
  int invulnerable = 0;
  int c;
  
  while (1) {
    int option_index = 0;
    static struct option long_options[] = { {"nbplayers", 1, 0, 'p'},
					    {"nbdisplays", 1, 0, 'd'},
					    {"help", 1, 0, 'h'},
					    {"invulnerable", 1, 0, 'i'},
					    {0, 0, 0, 0} };
    c = getopt_long (argc, argv, "?d:hip:12", long_options, &option_index);
    if (c == -1)
      break;
    
    switch (c) {
    case 0:
      break;
      
    case '1':
    case '2':
      nb_players = c - '0';
      nb_displays = 1;
      break;
      
    case 'd':
      nb_displays = atoi(optarg);
      nb_players = 2;
      break;
      
    case 'i':
      invulnerable = 1;
      break;
      
    case 'p':
      nb_displays = 1;
      nb_players = atoi(optarg);
      break;
      
    case 'h':
    case '?':
      usage(argv[0]);
      exit(EXIT_SUCCESS);
      
    default:
      usage(argv[0]);
      exit(EXIT_FAILURE);
    }
  }
  Init_Jeu(nb_players, nb_displays, invulnerable); /* fonction a appeler avant le lancement du jeu */
  Interface_Jeu(nb_players, nb_displays); /* lancement de l'interface */
  Fin_Jeu(); /* fonction a appeler apres la fin du jeu */

  return EXIT_SUCCESS;
}

